diff --git a/ChangeLog.adoc b/ChangeLog.adoc
index e431989247..e2f78afd2e 100644
--- a/ChangeLog.adoc
+++ b/ChangeLog.adoc
@@ -27,6 +27,10 @@ Improvements::
   * core: add last start date in output of command /version after at least one /upgrade (issue #903)
   * irc: don't smart filter modes given to you (issue #530, issue #897)
 
+Bug fixes::
+
+  * core: fix delayed refresh when the signal SIGWINCH is received (terminal resized) (issue #902)
+
 Build::
 
   * core: fix compilation on FreeBSD with autotools (issue #276)
diff --git a/src/gui/curses/gui-curses-main.c b/src/gui/curses/gui-curses-main.c
index e584274bbb..9d03da8608 100644
--- a/src/gui/curses/gui-curses-main.c
+++ b/src/gui/curses/gui-curses-main.c
@@ -451,10 +451,6 @@ gui_main_loop ()
             gui_color_pairs_auto_reset_pending = 1;
         }
 
-        gui_main_refreshs ();
-        if (gui_window_refresh_needed && !gui_window_bare_display)
-            gui_main_refreshs ();
-
         if (gui_signal_sigwinch_received)
         {
             (void) hook_signal_send ("signal_sigwinch",
@@ -463,6 +459,10 @@ gui_main_loop ()
             gui_window_ask_refresh (2);
         }
 
+        gui_main_refreshs ();
+        if (gui_window_refresh_needed && !gui_window_bare_display)
+            gui_main_refreshs ();
+
         gui_color_pairs_auto_reset_pending = 0;
 
         /* execute fd hooks */
